﻿using Newtonsoft.Json;
using StatisticsService.Api.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace StatisticsService.Api.Clients
{
    public class ZarManagementClient : IZarManagementClient
    {
        private readonly HttpClient httpClient;

        public ZarManagementClient(HttpClient httpClient)
        {
            this.httpClient = httpClient;
        }

        public async Task<ZarResponse<ZarSubject>> GetSubjects(string subjectType)
             => await httpClient.GetFromJsonAsync<ZarResponse<ZarSubject>>($"api/v1/subjects/filtered?searchTerm=⠀&subjectType={subjectType}");
    }
}
