﻿using StatisticsService.Api.Workers;

namespace StatisticsService.Api.Extensions
{
    public static class ApplicationServiceCollectionExtensions
    {
        public static IServiceCollection AddWorkerServices(this IServiceCollection services, IConfiguration configuration)
        {
            // Workers
            services.AddCronJob((Action<IScheduleConfig<BankServiceCronService>>)(c =>
            {
                configuration.GetSection("BankServiceCronService").Bind(c);
                c.TimeZone = TimeZoneInfo.Utc;
            }));

            return services;
        }
    }
}
