﻿using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Resources;
using Subjects;
using System;
using ZData.Authentication.Extensions;
using ZData.Grpc.Extensions;

namespace StatisticsService.Api.Extensions
{
    public static class GrpcClientsServiceCollectionExtensions
    {
        public static IServiceCollection AddGrpcClients(this IServiceCollection services, IConfiguration configuration)
        {
            services.AddAadTokenProvider(configuration.GetSection("AdAuthenticationOptions"));

            services.AddGrpcClient<ResourceProvider.ResourceProviderClient>(o =>
            {
                o.Address = new Uri(configuration["ResourceService:BaseUrl"]);
            })
                .AddAadAccessTokenDelegatingHandler()
                .AddWebHandlerWithKeepAlive();

            return services;
        }
    }
}
