﻿using StatisticsService.Database;
using StatisticsService.Database.Models;
using StatisticsService.Dto;

namespace StatisticsService.Api.Repository.Mock
{
    public static class RepositoryMockData
    {
        /// <summary>
        /// Adds mock data to an inputted DB context
        /// </summary>
        /// <param name="db">Database context</param>
        public static StatisticsServiceDbContext AddMockData(this StatisticsServiceDbContext db)
        {
            //Mock data for use in testing with In-Memory databases
            var statisticsDay = new List<AggregatedEventDay>()
            {
                new AggregatedEventDay() {  TopicId = "company-c32e6b5b-ca63-48d0-91ab-d5c6cb781737", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 1, EventTime = DateTime.Parse("2022-03-28T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-94528933-6c15-472e-9e6f-0197f22a84d8", EventType = "ZData.Events.Bank.StatementsReceived", Count = 190, EventCount = 10, EventTime = DateTime.Parse("2022-03-27T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1ba21aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-27T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1ba12aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-27T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1ba32aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-26T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-4f0b870a-0df7-48ac-9f58-15171ecb463c", EventType = "ZData.Events.Bank.StatementsReceived", Count = 1, EventCount = 20, EventTime = DateTime.Parse("2022-03-23T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-2607d0e1-7166-4d10-a667-509fe1449369", EventType = "ZData.Events.Bank.StatementsReceived", Count = 10, EventCount = 5, EventTime = DateTime.Parse("2022-03-26T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-62451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, EventTime = DateTime.Parse("2022-03-24T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-95c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-24T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-b32e6b5b-ca63-48d0-91ab-d5c6cb781737", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 1, EventTime = DateTime.Parse("2022-03-21T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-84528933-6c15-472e-9e6f-0197f22a84d8", EventType = "ZData.Events.Bank.StatementsReceived", Count = 190, EventCount = 10, EventTime = DateTime.Parse("2022-03-24T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-0ba21aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-24T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-3f0b870a-0df7-48ac-9f58-15171ecb463c", EventType = "ZData.Events.Bank.StatementsReceived", Count = 1, EventCount = 20, EventTime = DateTime.Parse("2022-03-24T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1607d0e1-7166-4d10-a667-509fe1449369", EventType = "ZData.Events.Bank.StatementsReceived", Count = 10, EventCount = 5, EventTime = DateTime.Parse("2022-03-23T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-52451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, EventTime = DateTime.Parse("2022-03-28T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-85c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-28T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-28T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-4321cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-22T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-5678cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-26T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-8765cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-26T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-8444444f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-29T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-8666666f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-30T12:00:00")  },
                                            
                // Duplicate values         
                new AggregatedEventDay() {  TopicId = "company-0454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:00:00")  },
                new AggregatedEventDay() {  TopicId = "company-0454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:00:00")  },

            };

            //Mock data for use in testing with In-Memory databases
            var statisticsHour = new List<AggregatedEventHour>()
            {
                new AggregatedEventHour() { TopicId = "company-c32e6b5b-ca63-48d0-91ab-d5c6cb781737", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 1, EventTime = DateTime.Parse("2022-03-28T12:12:00")  },
                new AggregatedEventHour() { TopicId = "company-94528933-6c15-472e-9e6f-0197f22a84d8", EventType = "ZData.Events.Bank.StatementsReceived", Count = 190, EventCount = 10, EventTime = DateTime.Parse("2022-03-27T12:13:00")  },
                new AggregatedEventHour() { TopicId = "company-1ba21aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-27T12:14:00")  },
                new AggregatedEventHour() { TopicId = "company-1ba12aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-27T12:15:00")  },
                new AggregatedEventHour() { TopicId = "company-1ba32aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-26T12:16:00")  },
                new AggregatedEventHour() { TopicId = "company-4f0b870a-0df7-48ac-9f58-15171ecb463c", EventType = "ZData.Events.Bank.StatementsReceived", Count = 1, EventCount = 20, EventTime = DateTime.Parse("2022-03-23T12:17:00")  },
                new AggregatedEventHour() { TopicId = "company-2607d0e1-7166-4d10-a667-509fe1449369", EventType = "ZData.Events.Bank.StatementsReceived", Count = 10, EventCount = 5, EventTime = DateTime.Parse("2022-03-26T12:21:00")  },
                new AggregatedEventHour() { TopicId = "company-62451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, EventTime = DateTime.Parse("2022-03-24T12:22:00")  },
                new AggregatedEventHour() { TopicId = "company-95c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-24T12:23:00")  },
                new AggregatedEventHour() { TopicId = "company-1454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:24:00")  },
                new AggregatedEventHour() { TopicId = "company-b32e6b5b-ca63-48d0-91ab-d5c6cb781737", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 1, EventTime = DateTime.Parse("2022-03-21T12:25:00")  },
                new AggregatedEventHour() { TopicId = "company-84528933-6c15-472e-9e6f-0197f22a84d8", EventType = "ZData.Events.Bank.StatementsReceived", Count = 190, EventCount = 10, EventTime = DateTime.Parse("2022-03-24T12:26:00")  },
                new AggregatedEventHour() { TopicId = "company-0ba21aa5-1bcc-41ec-bae6-8645e7aa7d67", EventType = "ZData.Events.Bank.StatementsReceived", Count = 15, EventCount = 1, EventTime = DateTime.Parse("2022-03-24T12:33:00")  },
                new AggregatedEventHour() { TopicId = "company-3f0b870a-0df7-48ac-9f58-15171ecb463c", EventType = "ZData.Events.Bank.StatementsReceived", Count = 1, EventCount = 20, EventTime = DateTime.Parse("2022-03-24T12:34:00")  },
                new AggregatedEventHour() { TopicId = "company-1607d0e1-7166-4d10-a667-509fe1449369", EventType = "ZData.Events.Bank.StatementsReceived", Count = 10, EventCount = 5, EventTime = DateTime.Parse("2022-03-23T12:35:00")  },
                new AggregatedEventHour() { TopicId = "company-52451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, EventTime = DateTime.Parse("2022-03-28T12:36:00")  },
                new AggregatedEventHour() { TopicId = "company-85c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-28T12:37:00")  },
                new AggregatedEventHour() { TopicId = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-28T12:38:00")  },
                new AggregatedEventHour() { TopicId = "company-4321cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-22T12:39:00")  },
                new AggregatedEventHour() { TopicId = "company-5678cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-26T13:22:00")  },
                new AggregatedEventHour() { TopicId = "company-8765cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-26T12:23:00")  },
                new AggregatedEventHour() { TopicId = "company-8444444f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-29T12:12:00")  },
                new AggregatedEventHour() { TopicId = "company-8666666f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, EventTime = DateTime.Parse("2022-03-30T12:14:00")  },
                
                // Duplicate values
                new AggregatedEventHour() { TopicId = "company-0454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:11:00")  },
                new AggregatedEventHour() { TopicId = "company-0454ddb7-d69c-408e-a9e8-9423b38b244e", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 10, EventTime = DateTime.Parse("2022-03-22T12:12:00")  },
            };

            db.AggregatedEventsDay.AddRange(statisticsDay);
            db.SaveChanges();
            return db;
        }

        /// <summary>
        /// Method for getting mock data containing account numbers, by day
        /// </summary>
        public static List<StatisticsDto> AddMockStatisticsDayAccountNumber()
        {
            //With optional value AccountNumber, add to existing list when Account Number is added to model.
            return new List<StatisticsDto>() {
                new StatisticsDto() { Id = "company-52451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, Timestamp = DateTime.Parse("2022-03-24T12:00:00"), AccountNumber = "98022744552"  },
                new StatisticsDto() { Id = "company-85c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:00:00"), AccountNumber = "98022744551"    },
                new StatisticsDto() { Id = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:00:00"), AccountNumber = "98022744553"    },
                new StatisticsDto() { Id = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:00:00"), AccountNumber = "98022744554"    },
                new StatisticsDto() { Id = "company-5678cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-26T12:00:00"), AccountNumber = "98022744555"    },
                new StatisticsDto() { Id = "company-8765cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:00:00"), AccountNumber = "98022744556"    },
                new StatisticsDto() { Id = "company-8444444f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:00:00"), AccountNumber = "98022744557"    },
                new StatisticsDto() { Id = "company-8666666f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:00:00"), AccountNumber = "98022744558"    },
            };
        }

        /// <summary>
        /// Method for getting mock data containing account numbers, by hour
        /// </summary>
        public static List<StatisticsDto> AddMockStatisticsHourAccountNumber()
        {
            //With optional value AccountNumber, add to existing list when Account Number is added to model.
            return new List<StatisticsDto>() {
                new StatisticsDto() { Id = "company-52451738-e89f-4ff6-944b-9e53d8663bc7", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 3, Timestamp = DateTime.Parse("2022-03-24T12:31:00"), AccountNumber = "98022744552"  },
                new StatisticsDto() { Id = "company-85c0cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:33:00"), AccountNumber = "98022744551"    },
                new StatisticsDto() { Id = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:34:00"), AccountNumber = "98022744553"    },
                new StatisticsDto() { Id = "company-1234cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:44:00"), AccountNumber = "98022744554"    },
                new StatisticsDto() { Id = "company-5678cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-26T12:55:00"), AccountNumber = "98022744555"    },
                new StatisticsDto() { Id = "company-8765cd6f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:56:00"), AccountNumber = "98022744556"    },
                new StatisticsDto() { Id = "company-8444444f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-28T12:57:00"), AccountNumber = "98022744557"    },
                new StatisticsDto() { Id = "company-8666666f-18fb-4b77-892d-1849b4180302", EventType = "ZData.Events.Bank.ReceivableReceived", Count = 10, EventCount = 8, Timestamp = DateTime.Parse("2022-03-27T12:58:00"), AccountNumber = "98022744558"    },
            };
        }

        /// <summary>
        /// Method for getting mock users.
        /// </summary>
        public static List<User> AddMockUsers()
        {
            return new List<User>()
            {
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-c32e6b5b-ca63-48d0-91ab-d5c6cb781737", Timestamp = DateTime.Parse("2022-05-04T12:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Henrik Hammer", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-06T13:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Anders Buanes", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-08T12:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Mikael Aare", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-08T13:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-c32e6b5b-ca63-48d0-91ab-d5c6cb781737", Timestamp = DateTime.Parse("2022-05-08T08:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-07T09:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-07T10:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-8666666f-18fb-4b77-892d-1849b4180302", Timestamp = DateTime.Parse("2022-05-07T11:35:05.5366733Z") },
                new User() { Id = Guid.NewGuid(), Name = "Markus Bjermeland", ResourceId = "company-c32e6b5b-ca63-48d0-91ab-d5c6cb781737", Timestamp = DateTime.Parse("2022-05-06T12:35:05.5366733Z") }
            };
        }
    }
}
