﻿using Cronos;
using System.Collections.ObjectModel;

namespace StatisticsService.Api.Workers
{
    public class CronExpressionCollection : Collection<CronExpression>
    {
        public DateTimeOffset? GetNextOccurrence(DateTimeOffset from, TimeZoneInfo zone)
        {
            var nextOccurrence = Items.Select(cron => cron.GetNextOccurrence(from, zone)).OrderBy(next => next).FirstOrDefault();
            return nextOccurrence;
        }

        public void AddExpressions(params string[] expressions)
        {
            foreach (var expression in expressions)
            {
                Add(CronExpression.Parse(expression));
            }
        }

        public override string ToString()
        {
            if (Items.Count == 0)
                return Items.First().ToString();
            return "[ " + String.Join(", ", Items.Select(i => i.ToString())) + " ]";
        }
    }
}
