﻿using System.Collections.Generic;
using System.Threading.Tasks;

namespace StatisticsService.Constants
{
    /// <summary>
    /// Class of constants used to define available resource types in API.
    /// </summary>
    public class Resources
    {
        /// <summary> Company </summary>
        public const string Company = "company";

        /// <summary> Partner </summary>
        public const string Partner = "partner";

        /// <summary>
        /// Returns all valid resource types as a list of strings
        /// </summary>
        public static readonly List<string> AllResourceTypes = new() { Company, Partner };

        /// <summary>
        /// Asynchronously returns all valid resource types as a list of strings
        /// </summary>
        public static readonly Task<List<string>> AllResourceTypesAsync = Task.Run(() => new List<string>{ Company, Partner});
    }
}
