﻿using Microsoft.EntityFrameworkCore;
using StatisticsService.Database.Models;

namespace StatisticsService.Database
{
    public class StatisticsServiceDbContext : DbContext
    {
        public StatisticsServiceDbContext(DbContextOptions options) : base(options) { }
        public DbSet<AggregatedEventHour> AggregatedEventsHour { get; set; } = null!;
        public DbSet<AggregatedEventDay> AggregatedEventsDay { get; set; } = null!;
        //public DbSet<User> Users { get; set; } = null!;
        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<AggregatedEventHour>().HasKey(table =>
                new { table.Id, table.EventTime });

            modelBuilder.Entity<AggregatedEventHour>().HasIndex(table =>
                new { table.TopicId, table.EventTime });

            modelBuilder.Entity<AggregatedEventHour>().HasIndex(table =>
                new { table.EventType, table.EventTime });

            modelBuilder.Entity<AggregatedEventHour>().HasIndex(table =>
                new { table.TopicId, table.EventType, table.EventTime });

            modelBuilder.Entity<AggregatedEventHour>().HasIndex(table =>
                new { table.ResourceType, table.EventTime });

            modelBuilder.Entity<AggregatedEventDay>().HasKey(table =>
                new { table.Id, table.EventTime });

            modelBuilder.Entity<AggregatedEventDay>().HasIndex(table =>
                new { table.TopicId, table.EventTime });

            modelBuilder.Entity<AggregatedEventDay>().HasIndex(table =>
                new { table.EventType, table.EventTime });

            modelBuilder.Entity<AggregatedEventDay>().HasIndex(table =>
                new { table.TopicId, table.EventType, table.EventTime });

            modelBuilder.Entity<AggregatedEventDay>().HasIndex(table =>
                new { table.ResourceType, table.EventTime });

            //modelBuilder.Entity<User>().HasKey(table =>
            //    new { table.Id, table.ResourceId });
        }
    }
}