import { Link } from 'react-router-dom'

import { capitalize } from 'utils'

interface BreadcrumbItemProps {
  label: string
  url?: string
  active?: boolean
}

export const BreadcrumbItem = ({ label, url, active }: BreadcrumbItemProps) => {
  return (
    <li
      className={`breadcrumb-item${active ? ' active' : ''}`}
      {...(active && { 'aria-current': 'page' })}
    >
      {url && <Link to={url}>{label === '' ? 'Home' : capitalize(label)}</Link>}
      {!url && (!active ? <span>{capitalize(label)}</span> : capitalize(label))}
    </li>
  )
}
