import { useAuth } from 'react-oidc-context'
import { AlertCircle, User } from 'react-feather'
import Gravatar from 'react-gravatar'

interface Profile {
  email?: string
  full_name?: string
}

export const ProfileDropdown = () => {
  const auth = useAuth()

  const profile: Profile | undefined = auth.user?.profile

  return (
    <>
      <a data-bs-toggle="dropdown" className="nav-link leading-none d-flex">
        <Gravatar
          email={profile?.email ?? 'no-reply@zdata.no'}
          alt="profile-user"
          className="avatar profile-user brround cover-image"
          protocol="https://"
        />
      </a>
      <div className="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
        <div className="drop-heading">
          <div className="text-center">
            <h5 className="text-dark mb-0 fs-14 fw-semibold">{profile?.full_name}</h5>
            <small className="text-muted">ZData Employee</small>
          </div>
        </div>
        <div className="dropdown-divider m-0"></div>
        <a
          className="dropdown-item"
          href={`${process.env.REACT_APP_IDENTITY_SERVER_URL}/User/Profile/Account`}
          target="_blank"
        >
          <User className="dropdown-icon" /> Profile
        </a>
        <button
          style={{ cursor: 'pointer' }}
          className="dropdown-item"
          onClick={() => auth.signoutRedirect()}
        >
          <AlertCircle className="dropdown-icon" /> Sign out
        </button>
      </div>
    </>
  )
}
