import { ChangeEvent } from 'react'

import { capitalize } from 'utils'

interface WidgetRadioProps {
  checkedValue: string
  onChange: (e: ChangeEvent<HTMLInputElement>) => void
  value: string
}

export const WidgetRadio = ({ checkedValue, onChange, value }: WidgetRadioProps) => {
  return (
    <>
      <label className="widget-radio">
        <input
          className="widget-radio-element"
          type="radio"
          checked={checkedValue === value}
          onChange={onChange}
          value={value}
        />
        <span>{capitalize(value)}</span>
      </label>
    </>
  )
}
