import { Helmet } from 'react-helmet-async'
import { useNavigate } from 'react-router-dom'
import { Aperture, CreditCard, Package } from 'react-feather'

import { Content } from 'app/components/Content'

export const DashboardPage = () => {
  const navigate = useNavigate()

  return (
    <>
      <Helmet>
        <title>Dashboard</title>
      </Helmet>
      <Content category="Home" currentPage="Dashboard">
        <div className="row">
          <div className="col-sm-12 col-md-12 col-lg-12 col-xl-6">
            <div
              className="card bg-facebook-gradient img-card box-primary-shadow pe-auto"
              onClick={() => navigate('/projects/bankservice')}
            >
              <div className="card-body">
                <div className="d-flex">
                  <div className="text-white">
                    <h2 className="mb-0 number-font">Bank Service</h2>
                    <p className="text-white mb-0">ZData Banking API</p>
                  </div>
                  <div className="ms-auto">
                    <Package className="text-white fs-50 me-2 mt-2" size={35} />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div className="col-sm-12 col-md-12 col-lg-12 col-xl-6">
            <div
              className="card bg-info-dark-gradient img-card box-primary-shadow pe-auto"
              onClick={() => navigate('/projects/settlement')}
            >
              <div className="card-body">
                <div className="d-flex">
                  <div className="text-white">
                    <h2 className="mb-0 number-font">Settlement</h2>
                    <p className="text-white mb-0">Automatic Card Transactions</p>
                  </div>
                  <div className="ms-auto">
                    <CreditCard className="text-white fs-50 me-2 mt-2" size={35} />
                  </div>
                </div>
              </div>
            </div>
          </div>
          {/* <div className="col-sm-12 col-md-12 col-lg-12 col-xl-4">
            <div
              className="card bg-primary-gradient img-card box-primary-shadow pe-auto"
              onClick={() => navigate('/projects/control')}
            >
              <div className="card-body">
                <div className="d-flex">
                  <div className="text-white">
                    <h2 className="mb-0 number-font">Control</h2>
                    <p className="text-white mb-0">Automatic Bank Reconciliation</p>
                  </div>
                  <div className="ms-auto">
                    <Aperture className="text-white fs-50 me-2 mt-2" size={35} />
                  </div>
                </div>
              </div>
            </div>
          </div> */}
        </div>
      </Content>
    </>
  )
}
