import { Helmet } from 'react-helmet-async'

import { Content } from 'app/components/Content'
import { Graph } from 'app/components/widgets/Graph'
import { PlaceholderSmallWidget } from 'app/components/widgets/PlaceholderSmallWidget'
import EventType from 'shared/enums/event-type.enum'
import StatisticsParameters from 'shared/interfaces/graph/statistics-parameters.interface'

export const SettlementPage = () => {
  const defaultGraphParameters: StatisticsParameters = {
    eventType: EventType.receivables,
    timeType: '7-day',
  }
  return (
    <>
      <Helmet>
        <title>Settlement</title>
      </Helmet>
      <Content
        category="projects"
        currentPage="Settlement"
        badgeText="Consists of mock data until further"
      >
        <div className="row">
          <div className="col-lg-12 col-md-12 col-sm-12 col-xl-12">
            <div className="row">
              <PlaceholderSmallWidget
                type="line"
                variant="pink"
                title="Customers"
                data={[60, 52, 79, 76, 31, 64, 54]}
                value={547}
              />
              <PlaceholderSmallWidget
                type="line"
                variant="warning"
                title="Partners"
                data={[60, 52, 79, 76, 31, 64, 54]}
                value={43}
              />
              <PlaceholderSmallWidget
                type="line"
                variant="green"
                title="Merchants"
                data={[60, 52, 79, 76, 31, 64, 54]}
                value={1528}
              />
            </div>
          </div>
        </div>
        <div className="row">
          <Graph
            type="line"
            variant="primary"
            title="Transactions Count"
            args={{ ...defaultGraphParameters }}
          />
          <Graph
            type="line"
            variant="primary"
            title="Transactions Volume"
            args={{ ...defaultGraphParameters, eventType: EventType.statements }}
          />
        </div>
      </Content>
    </>
  )
}
