import 'react-app-polyfill/ie11'
import 'react-app-polyfill/stable'

import * as React from 'react'
import * as ReactDOM from 'react-dom'
import FontFaceObserver from 'fontfaceobserver'
import reportWebVitals from 'reportWebVitals'

import { App } from 'app/App'
import { Root } from 'app/Root'

import '@popperjs/core'
import 'bootstrap'

const fontObserver = new FontFaceObserver('IBM Plex Sans', {})
fontObserver.load().then(() => {
  document.body.classList.add('fontLoaded')
})

ReactDOM.render(
  <Root>
    <React.StrictMode>
      <App />
    </React.StrictMode>
  </Root>,
  document.querySelector('#root'),
)

reportWebVitals(console.log)
