import { StateCreator } from 'zustand'

export interface IThemeSlice {
  isDarkMode: boolean
  toggleTheme: () => void
}

const isSystemDark = window?.matchMedia
  ? window.matchMedia('(prefers-color-scheme: dark)')?.matches
  : false

export const createThemeSlice: StateCreator<IThemeSlice> = set => ({
  isDarkMode: isSystemDark,
  toggleTheme: (): void => set(state => ({ isDarkMode: !state.isDarkMode })),
})
