import { AuthProviderProps } from 'react-oidc-context'

const configuration: AuthProviderProps = {
  client_id: 'StatisticsClient',
  redirect_uri: `${window.location.protocol}//${window.location.hostname}${
    window.location.port ? `:${window.location.port}` : ''
  }/authentication/callback`,
  response_type: 'code',
  scope: 'openid profile roles services.statistics services.resource',
  authority: process.env.REACT_APP_IDENTITY_SERVER_URL ?? '',
  silent_redirect_uri: `${window.location.protocol}//${window.location.hostname}${
    window.location.port ? `:${window.location.port}` : ''
  }/oidc-silent-renew`,
  automaticSilentRenew: true,
  filterProtocolClaims: true,
  loadUserInfo: true,
}

export default configuration
