import { useQuery } from 'react-query'
import { AxiosError } from 'axios'

import { getStatistics } from '../api/statistics'
import { FETCH_DEFAULT_OPTIONS } from './config'
import AggregatedStatistics from 'shared/interfaces/graph/aggregated-statistics.interface'
import StatisticsParameters from 'shared/interfaces/graph/statistics-parameters.interface'

export const useStatistics = (args: StatisticsParameters) => {
  return useQuery<AggregatedStatistics[], AxiosError>(
    [
      `${args.eventType}-${args.timeType}-${
        args.resourceId ? `${args.resourceId}-` : ''
      }statistics`,
      args,
    ],
    () => getStatistics(args),
    FETCH_DEFAULT_OPTIONS,
  )
}
