import { useQuery } from 'react-query'
import { AxiosError } from 'axios'

import { getWidget } from '../api'
import { FETCH_ONCE_OPTIONS } from './config'
import WidgetParameters from 'shared/interfaces/widget/widget-parameters'
import WidgetResponse from 'shared/interfaces/widget/widget-response.interface'

export const useWidget = (args: WidgetParameters) => {
  return useQuery<WidgetResponse, AxiosError>(
    [`${args.widgetType}-widget`, args],
    () => getWidget(args),
    FETCH_ONCE_OPTIONS,
  )
}
